import torch
from torch_geometric.transforms import LocalDegreeProfile
from torch_geometric.data import Data


def test_target_indegree():
    assert LocalDegreeProfile().__repr__() == 'LocalDegreeProfile()'

    edge_index = torch.tensor([[0, 1, 1, 2], [1, 0, 2, 1]])
    x = torch.Tensor([[1], [1], [1], [1]])  # One isolated node.

    expected = [[1, 2, 2, 2, 0], [2, 1, 1, 1, 0], [1, 2, 2, 2, 0],
                [0, 0, 0, 0, 0]]

    data = Data(edge_index=edge_index, pos=x)
    data = LocalDegreeProfile()(data)
    assert data.x.tolist() == expected

    data.x = x
    data = LocalDegreeProfile()(data)
    assert data.x[:, 1:].tolist() == expected
    assert data.x[:, 0].tolist() == [1, 1, 1, 1]
